"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.buildFlow = void 0;
var shelljs_1 = __importDefault(require("shelljs"));
var file_1 = require("@/util/file");
var taskQueue_1 = __importDefault(require("@/util/taskQueue"));
var util_1 = require("@/util");
var buildFlow = function () { return __awaiter(void 0, void 0, void 0, function () {
    var taskQueue, exist, buildConfig, flow_1;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                taskQueue = new taskQueue_1.default();
                exist = (0, file_1.ConfigExist)("rsw.config.ts");
                buildConfig = {};
                if (exist) {
                    buildConfig = (0, file_1.loadTsConfig)("rsw.config.ts");
                }
                if (!buildConfig.flow) return [3 /*break*/, 3];
                flow_1 = buildConfig.flow;
                if (!flow_1.preHook) return [3 /*break*/, 2];
                (0, util_1.loggerInfo)("stage.preHook==>".concat(flow_1.preHook));
                return [4 /*yield*/, shelljs_1.default.exec(flow_1.preHook)];
            case 1:
                _a.sent();
                _a.label = 2;
            case 2:
                // Add task into queue
                flow_1 === null || flow_1 === void 0 ? void 0 : flow_1.stages.forEach(function (stage) {
                    if (flow_1[stage].script) {
                        (0, util_1.loggerInfo)("stage.script==>".concat(flow_1[stage].script));
                        taskQueue.enqueue(function () { return __awaiter(void 0, void 0, void 0, function () {
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0:
                                        if (!flow_1[stage].preHook) return [3 /*break*/, 2];
                                        return [4 /*yield*/, shelljs_1.default.exec(flow_1[stage].preHook)];
                                    case 1:
                                        _a.sent();
                                        _a.label = 2;
                                    case 2: return [4 /*yield*/, shelljs_1.default.exec(flow_1[stage].script)];
                                    case 3:
                                        _a.sent();
                                        if (!flow_1[stage].doneHook) return [3 /*break*/, 5];
                                        return [4 /*yield*/, shelljs_1.default.exec(flow_1[stage].doneHook)];
                                    case 4:
                                        _a.sent();
                                        _a.label = 5;
                                    case 5: return [2 /*return*/];
                                }
                            });
                        }); });
                    }
                });
                if (flow_1.doneHook) {
                    taskQueue.enqueue(function () { return __awaiter(void 0, void 0, void 0, function () {
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    (0, util_1.loggerInfo)("stage.doneHook==>".concat(flow_1.doneHook));
                                    return [4 /*yield*/, shelljs_1.default.exec(flow_1.doneHook)];
                                case 1:
                                    _a.sent();
                                    return [2 /*return*/];
                            }
                        });
                    }); });
                }
                // Execute queue
                taskQueue.start();
                _a.label = 3;
            case 3: return [2 /*return*/];
        }
    });
}); };
exports.buildFlow = buildFlow;
