"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.loadTpl = exports.getTplList = exports.updateTpl = void 0;
var util_1 = require("@/util");
var file_1 = require("@/util/file");
var download_git_repo_1 = __importDefault(require("download-git-repo"));
var cacheTpl = '.igCache';
/**
 * @description: 添加模板信息
 * @param {ITpl} params
 * @return {*}
 */
var updateTpl = function (params) { return __awaiter(void 0, void 0, void 0, function () {
    var tplUrl, name, desc, pathname, isExist, reTpl_1, tplConfig, file;
    return __generator(this, function (_a) {
        tplUrl = params.tplUrl, name = params.name, desc = params.desc;
        pathname = new URL(tplUrl).pathname;
        isExist = false;
        try {
            reTpl_1 = {
                tplUrl: tplUrl,
                name: name,
                desc: desc
            };
            if (tplUrl.includes('github.com')) {
                reTpl_1.org = pathname.substring(1);
                reTpl_1.downloadUrl = 'https://codeload.github.com';
                reTpl_1.apiUrl = 'https://api.github.com';
            }
            tplConfig = (0, file_1.loadFile)("".concat(cacheTpl, "/.tpl.json"));
            file = [reTpl_1];
            if (tplConfig) {
                isExist = tplConfig.some(function (tpl) { return tpl.name === name; });
                if (isExist) {
                    file = tplConfig.map(function (tpl) {
                        if (tpl.name === name) {
                            return reTpl_1;
                        }
                        return tpl;
                    });
                }
                else {
                    file = __spreadArray(__spreadArray([], tplConfig, true), file, true);
                }
            }
            (0, file_1.writeFile)(cacheTpl, '.tpl.json', file);
            (0, util_1.loggerSuccess)("".concat(isExist ? 'Update' : 'Add', " Template Successful!"));
        }
        catch (error) {
            (0, util_1.loggerError)(error);
        }
        return [2 /*return*/];
    });
}); };
exports.updateTpl = updateTpl;
/**
 * @description: 获取模板列表
 * @param {*}
 * @return {*}
 */
var getTplList = function () {
    try {
        var tplConfig = (0, file_1.loadFile)("".concat(cacheTpl, "/.tpl.json"));
        if (tplConfig) {
            return tplConfig;
        }
        (0, util_1.loggerWarning)('No template! Please add template first!');
        process.exit(1);
    }
    catch (err) {
        (0, util_1.loggerError)(err);
    }
};
exports.getTplList = getTplList;
var loadTpl = function (name, downloadUrl, path) {
    (0, download_git_repo_1.default)("direct:".concat(downloadUrl), (0, util_1.getCwdPath)("./".concat(path)), function (err) {
        if (err) {
            (0, util_1.loggerError)(err);
        }
        else {
            (0, util_1.loggerSuccess)("Download ".concat(name, " Template Successful!"));
        }
    });
};
exports.loadTpl = loadTpl;
